﻿//////////////////////////////////////////////////////////////////////////////////////////
//                                                                                      //
//  Anwendung                                                                           //
//  _____________________________________________________                               //
//                                                                                      //
//  Copyright (c) 2019 Reimar Grasbon                                                   //
//                                                                                      //
//////////////////////////////////////////////////////////////////////////////////////////
//                                                                                      //
//  This software is subjected to the FreeBSD License. Redistribution and use in source //
//  and binary forms, with or without modification, are permitted provided that the     //
//  following conditions are met:                                                       //
//                                                                                      //
//  1. Redistributions of source code must retain the above copyright notice, this list //
//     of conditions and the following disclaimer.                                      //
//                                                                                      //
//  2. Redistributions in binary form must reproduce the above copyright notice, this   //
//     list of conditions and the following disclaimer in the documentation and/or      //
//     other materials provided with the distribution.                                  //
//                                                                                      //
//  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY //
//  EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED           //
//  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  //
//  IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,    //
//  INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT  //
//  NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR  //
//  PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,   //
//  WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)  //
//  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE          //
//  POSSIBILITY OF SUCH DAMAGE.                                                         //
//                                                                                      //
//////////////////////////////////////////////////////////////////////////////////////////

#pragma once

#include "TypeDefs.h"
#include "DateTime.h"

//////////////////////////////////////////////////////////////////////////////////////////
//  Definitionen  ////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////
#define AUTO_TIMER_INVALID  {   false,                                       \
                                TIME_INVALID,                                \
                                TIME_INVALID,                                \
                                { true, true, true, true, true, true, true } \
                            }

//////////////////////////////////////////////////////////////////////////////////////////
//  Typen  ///////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////
typedef enum                           // Signale der grünen Info-LED
{   INFOLEDSIGNAL_OFF         = 0,     // · Kein Signal, Ausgeschaltet.
    INFOLEDSIGNAL_ON          = 1,     // · Leuchtet durchgehend.
    INFOLEDSIGNAL_HEARTBEAT   = 2,     // · Herzschlag-Signal (Voreinstellung).
    INFOLEDSIGNAL_BUS_ACT     = 3      // · Zeigt Aktivität auf dem Bus.
} InfoLedSignal;

typedef enum
{   POWER_SWITCH_MODE_OFF        = 0,
	POWER_SWITCH_MODE_ON         = 1,    
	POWER_SWITCH_MODE_TIMER      = 2,
	POWER_SWITCH_MODE_BRIGHTNESS = 3
} PowerSwitchMode;

typedef enum
{   BRIGHTNESS_MODE_LIGHT_OFF_DARK_ON = 0,
	BRIGHTNESS_MODE_LIGHT_ON_DARK_OFF = 1
} BrightnessMode;

typedef struct 
{   bool     enabled;
    Time     startTime;
    Time     endTime;
    bool     weekDay[7];
} AutoTimer;

//////////////////////////////////////////////////////////////////////////////////////////
//  Prozessaufrufe  //////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////
void    APPLICATION_Startup(void);
void    APPLICATION_Proceed(void);
void    APPLICATION_Shutdown(void);

//////////////////////////////////////////////////////////////////////////////////////////
