﻿//////////////////////////////////////////////////////////////////////////////////////////
//                                                                                      //
//  Cy4NET-Link                                                                         //
//  ____________                                                                        //
//                                                                                      //
//  Copyright 2010 Reimar Grasbon                                                       //
//                                                                                      //
//////////////////////////////////////////////////////////////////////////////////////////
//                                                                                      //
//  This software is subjected to the FreeBSD License. Redistribution and use in source //
//  and binary forms, with or without modification, are permitted provided that the     //
//  following conditions are met:                                                       //
//                                                                                      //
//  1. Redistributions of source code must retain the above copyright notice, this list //
//     of conditions and the following disclaimer.                                      //
//                                                                                      //
//  2. Redistributions in binary form must reproduce the above copyright notice, this   //
//     list of conditions and the following disclaimer in the documentation and/or      //
//     other materials provided with the distribution.                                  //
//                                                                                      //
//  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY //
//  EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED           //
//  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  //
//  IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,    //
//  INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT  //
//  NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR  //
//  PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,   //
//  WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)  //
//  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE          //
//  POSSIBILITY OF SUCH DAMAGE.                                                         //
//                                                                                      //
//////////////////////////////////////////////////////////////////////////////////////////

#include "Cy4Link.h"

//////////////////////////////////////////////////////////////////////////////////////////
Cy4Link
CY4LINK_Create(Cy4Address address, UInt32 location)
{
    Cy4Link  dest = { address, location };
    return dest;
}

//////////////////////////////////////////////////////////////////////////////////////////
bool
CY4LINK_IsValid(const Cy4Link* link)
{
    return CY4ADDRESS_IsValid(&link->address) && link->location < 0xFFFFFF;
}

//////////////////////////////////////////////////////////////////////////////////////////
void
CY4LINK_FromData(const UInt08* data, Cy4Link* link)
{
    Cy4Address address = CY4ADDRESS(data[0], data[1]);
    link->address = address;
    link->location = ((UInt32)data[2] << 16) + ((UInt16)data[3] << 8) + data[4];
}

//////////////////////////////////////////////////////////////////////////////////////////
void
CY4LINK_ToData(const Cy4Link* link, UInt08* data)
{
    data[0] = link->address.net;
    data[1] = link->address.dev;
    data[2] = (UInt08)(link->location >> 16);
    data[3] = (UInt08)(link->location >>  8);
    data[4] = (UInt08)(link->location >>  0);
}

//////////////////////////////////////////////////////////////////////////////////////////
